WITH 
pc AS materialized (
    SELECT
         STLC 
        ,COALESCE(COLTIER,'') COLTIER 
        ,coalesce(BRANDING,'' ) branding
        ,COALESCE(ACCS ,'') ACCS
        ,COALESCE(SUFF,'') SUFFIX
        ----price 1 -----------------
        ,PCKG PCKG1
        ,1 VOLL1
        ,PCKG VOL1_UOM
        ,PACK VOL1_PRICE
        ----price 2 -----------------
        ,PCKG PCKG2
        ,1 VOLl2
        ,'PLT' VOL2_UOM
        ,MP VOL2_PRICE
        ----price 3 -----------------
        ,'PLT' PCKG3
        ,1 VOLL3
        ,'PLT' VOL3_UOM
        ,BULK VOL3_PRICE
    FROM
        rlarp.PCORE P
)
,colors AS (
SELECT
     pc.STLC 
    ,pc.COLTIER 
    ,pc.branding
    ,pc.ACCS
    ,pc.SUFFIX
    ,string_agg( DISTINCT ltrim(rtrim(i.COLC)),', ') clist
    ----price 1 -----------------
    ,pc.PCKG1
    ,pc.VOLL1
    ,pc.VOL1_UOM
    ,pc.VOL1_PRICE
    ----price 2 -----------------
    ,pc.PCKG2
    ,pc.VOLl2
    ,pc.VOL2_UOM
    ,pc.VOL2_PRICE
    ----price 3 -----------------
    ,pc.PCKG1
    ,pc.VOLL3
    ,pc.VOL3_UOM
    ,pc.VOL3_PRICE
FROM    
    pc
    LEFT OUTER JOIN RLARP.ITEMMv i ON
        i.STLC = pc.stlc
        AND i.COLTIER = pc.coltier
        --relax relationship to pick up any colors that we run for the mold and color tier
        --AND COALESCE(i.BRANDING,'') = pc.branding
        --AND COALESCE(i.ACCS,'') = pc.ACCS
        --AND COALESCE(i.SUFFIX,'') = pc.suffix
        AND APLNT <> 'I'
GROUP BY 
     pc.STLC 
    ,pc.COLTIER 
    ,pc.branding
    ,pc.ACCS
    ,pc.SUFFIX
    ----price 1 -----------------
    ,pc.PCKG1
    ,pc.VOLL1
    ,pc.VOL1_UOM
    ,pc.VOL1_PRICE
    ----price 2 -----------------
    ,pc.PCKG2
    ,pc.VOLl2
    ,pc.VOL2_UOM
    ,pc.VOL2_PRICE
    ----price 3 -----------------
    ,pc.PCKG1
    ,pc.VOLL3
    ,pc.VOL3_UOM
    ,pc.VOL3_PRICE
)
-----------since joining to the item master will be differnt for the last bulk columm---------------
-----------must first pivot the data out then join based on the type of row-------------------------
,unpivot AS (
    SELECT
        pc.stlc
        ,pc.coltier
        ,pc.branding
        ,pc.accs
        ,pc.suffix
        ,pc.pckg1 pckg
        ,pc.vol1_uom vol_uom
    FROM
        pc
    UNION
    SELECT
        pc.stlc
        ,pc.coltier
        ,pc.branding
        ,pc.accs
        ,pc.suffix
        ,pc.pckg2 pckg
        ,pc.vol2_uom vol_uom
    FROM
        pc
    UNION
    SELECT
        pc.stlc
        ,pc.coltier
        ,pc.branding
        ,pc.accs
        ,pc.suffix
        ,pc.pckg3 pckg
        ,pc.vol3_uom vol_uom
    FROM
        pc
)
----link to actual part numbers, tag the sequence so a single item can be chosen-----
,items_init AS (
SELECT 
     up.STLC
    ,up.coltier
    ,up.branding
    ,up.accs
    ,up.suffix
    ,up.pckg
    ,up.vol_uom
    ,row_number() OVER (PARTITION BY up.stlc, up.coltier, up.branding, up.accs, up.suffix ORDER BY item DESC) seq
    ,item
FROM    
    unpivot up
    LEFT OUTER JOIN RLARP.ITEMMv i ON
        i.STLC = up.stlc
        --AND i.COLTIER = pc.coltier
        AND i.uomp ? up.pckg
        AND COALESCE(i.BRANDING,'') = up.branding
        AND COALESCE(i.ACCS,'') = up.ACCS
        AND COALESCE(i.SUFFIX,'') = up.suffix
        AND APLNT <> 'I'
)
----compile all the conversions into a single json object
,items AS (
    SELECT
        jsonb_agg( DISTINCT 
            jsonb_build_object(
                'partn', item
                ,'fu', vol_uom
                ,'tu','PC'
            )
        ) conv
    FROM 
        items_init 
    WHERE 
        seq = 1
        AND COALESCE(item,'') <> ''
)
, conversion AS (
    SELECT
        rslt.* 
    FROM
        items 
        JOIN LATERAL rlarp.uom_array(conv) rslt ON true
)
--SELECT * FROM conversion
SELECT 
    i.*
    ,c.*
FROM
    items_init i
    LEFT OUTER JOIN conversion c ON
        c.p = i.item
WHERE
    i.seq = 1
ORDER BY
    stlc
    ,coltier
